import { Liquid } from 'liquidjs'
import pov from 'point-of-view'
import path from 'path'

/**
 *  plugin: usindg render engine liquidjs
 *
 *  @author Björn Hase, me@herr-hase.wtf
 *  @license http://opensource.org/licenses/MIT The MIT License
 *  @link https://gitea.node001.net/HerrHase/super-hog
 *
 */

async function plugin(fastify, options)
{
    const engine = new Liquid({
        root: path.join(path.resolve(), '/../../frontend/views'),
        extname: '.liquid',
    })

    fastify.register(pov, {
        engine: {
            liquid: engine
        }
    })
}

export default plugin